function [Ix, Iy, It, I2_warped] = warping(I1, I2, u, v)

[M N C] = size(I1);

%% Compute warped image
idx = repmat([1:N], M,1) + u;
idy = repmat([1:M]',1,N) + v;
boundary = (idx > N) | (idx < 1) | (idy > M) | (idy < 1);

idx = max(1, min(N, idx));
idy = max(1, min(M, idy));
I2_warped = interp2(I2,idx,idy,'bilinear',0);

%% Compute temproal derivative
It = I2_warped  - I1;

%% Compute spatial derivatives
mask = [-1 0 1]/2;

Ix = imfilter(I2_warped, mask, 'symmetric');
Iy = imfilter(I2_warped, mask', 'symmetric');