close all;
clear;

load('example_data.mat');
l1 = l1(200:250);
l1x = imfilter(l1, [-1 0 1]/2,'symmetric');
I = max(l1);
u=1:length(l1);

h=figure(1);hold on;
plot([1:51], ones(length(l1),1)*I, 'r', 'linewidth', 2.0); 
plot([1:51], l1, 'b', 'linewidth', 2.0); hold off;
handle = gca;
fontsize = 15;
set(handle,'Fontsize',fontsize);
l=legend('$I_1(x)$','$I_2(x+u)$','Location','SouthWest')
set(l,'Interpreter','latex');
xlim([1 51]);
xl = xlabel('$u$','Fontsize',fontsize);
set(xl,'Interpreter','latex');

print( h, '-depsc', 'lin1.eps');
cmd = 'ps2pdf -dEPSCrop lin1.eps lin1.pdf'; 
system(cmd);



h=figure(2); plot([1:51], abs(l1-I), 'k', 'linewidth', 2.0); hold on;

u0 = 11;
plot([1:51], abs(l1(u0)-I + l1x(u0)*(u-u0)), 'r', 'linewidth', 2);

u0 = 19;
plot([1:51], abs(l1(u0)-I + l1x(u0)*(u-u0)), 'g', 'linewidth', 2);

u0 = 22;
plot([1:51], abs(l1(u0)-I + l1x(u0)*(u-u0)), 'b', 'linewidth', 2);

u0 = 11;
plot(u0, abs(l1(u0)-I), 'ro', 'MarkerSize', 10, 'linewidth', 2.0);

u0 = 19;
plot(u0, abs(l1(u0)-I), 'go', 'MarkerSize', 10, 'linewidth', 2.0);

u0 = 22;
plot(u0, abs(l1(u0)-I), 'bo', 'MarkerSize', 10, 'linewidth', 2.0);

hold off;

handle = gca;
fontsize = 15;
set(handle,'Fontsize',fontsize);
l=legend('$|I_2(x+u)-\;\;I_1(x)|$',...
  '$|I_t + \nabla I_2(u-\;\;u0)|,\; u0=11$',...
  '$|I_t + \nabla I_2(u-\;\;u0)|,\;u0=19$',...
  '$|I_t + \nabla I_2(u-\;\;u0)|,\;u0=22$',...
  'Location','North')
set(l,'Interpreter','latex');
ylim([0 1/3]);
xlim([1 51]);
xl = xlabel('$u$','Fontsize',fontsize);
set(xl,'Interpreter','latex');

print( h, '-depsc', 'lin2.eps');
cmd = 'ps2pdf -dEPSCrop lin2.eps lin2.pdf'; 
system(cmd);
